﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using WiimoteLib;

namespace WiimoteTest
{
	public partial class MultipleWiimoteForm : Form
	{
		// map a wiimote to a specific state user control dealie
		Dictionary<Guid,WiimoteInfo> mWiimoteMap = new Dictionary<Guid,WiimoteInfo>();
		WiimoteCollection mWC;

		public MultipleWiimoteForm()
		{
			InitializeComponent();
		}

        private void MultipleWiimoteForm_Load(object sender, EventArgs e)
        {
            // find all wiimotes connected to the system
            mWC = new WiimoteCollection();
            int index = 1;

            try
            {
                mWC.FindAllWiimotes();
            }
            catch (WiimoteNotFoundException ex)
            {
                MessageBox.Show(ex.Message, "Wiimote not found error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (WiimoteException ex)
            {
                MessageBox.Show(ex.Message, "Wiimote error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Unknown error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            if (mWC.Count == 2 || mWC.Count == 1)
            {
                int i = 0;
                foreach (Wiimote wm in mWC)
                {
                    // create a new user control
                    WiimoteInfo wi = new WiimoteInfo(wm);
                    if (i == 0)
                    {
                        this.splitContainer1.Panel1.Controls.Add(wi);
                        i = 1;
                        String fName = "c:/temp/wii-left" + DateTime.Now.Day + DateTime.Now.Month + DateTime.Now.Year + 0 + ".txt";
                        wi.setFname(fName);
                    }
                    else
                    {
                        this.splitContainer1.Panel2.Controls.Add(wi);
                        String fName = "c:/temp/wii-right" + DateTime.Now.Day + DateTime.Now.Month + DateTime.Now.Year + 0 + ".txt";
                        wi.setFname(fName);
                    }
                    // setup the map from this wiimote's ID to that control
                    mWiimoteMap[wm.ID] = wi;
                    // connect it and set it up as always
                    wm.WiimoteChanged += wm_WiimoteChanged;
                    wm.WiimoteExtensionChanged += wm_WiimoteExtensionChanged;

                    wm.Connect();
                    if (wm.WiimoteState.ExtensionType != ExtensionType.BalanceBoard)
                        wm.SetReportType(InputReport.IRExtensionAccel, IRSensitivity.Maximum, true);

                    wm.SetLEDs(index++);

                }
            }
            else
            {
                MessageBox.Show( "Software Only Set up for max 2 wiimotes");
            }
            m_startTime = DateTime.Now;
            
        }

        static DateTime m_startTime;
        static public DateTime getStartTime()
        {
            return m_startTime;
        }
/*                foreach(Wiimote wm in mWC)
			{
				// create a new tab
				TabPage tp = new TabPage("Wiimote " + index);
				tabWiimotes.TabPages.Add(tp);

				// create a new user control
				WiimoteInfo wi = new WiimoteInfo(wm);
				tp.Controls.Add(wi);

				// setup the map from this wiimote's ID to that control
				mWiimoteMap[wm.ID] = wi;

				// connect it and set it up as always
				wm.WiimoteChanged += wm_WiimoteChanged;
				wm.WiimoteExtensionChanged += wm_WiimoteExtensionChanged;

				wm.Connect();
				if(wm.WiimoteState.ExtensionType != ExtensionType.BalanceBoard)
					wm.SetReportType(InputReport.IRExtensionAccel, IRSensitivity.Maximum, true);
				
				wm.SetLEDs(index++);
			}
		}*/

		void wm_WiimoteChanged(object sender, WiimoteChangedEventArgs e)
		{
			WiimoteInfo wi = mWiimoteMap[((Wiimote)sender).ID];
			wi.UpdateState(e);
		}

		void wm_WiimoteExtensionChanged(object sender, WiimoteExtensionChangedEventArgs e)
		{
			// find the control for this Wiimote
			WiimoteInfo wi = mWiimoteMap[((Wiimote)sender).ID];
			wi.UpdateExtension(e);

			if(e.Inserted)
				((Wiimote)sender).SetReportType(InputReport.IRExtensionAccel, true);
			else
				((Wiimote)sender).SetReportType(InputReport.IRAccel, true);
		}

		private void MultipleWiimoteForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			foreach(Wiimote wm in mWC)
				wm.Disconnect();
		}

        private void tabWiimotes_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
	}
}
